import { GlobalTouchListener } from "./GlobalTouchListener";

const { ccclass, property } = cc._decorator;

@ccclass
export class GameMgr extends cc.Component {

    @property(GlobalTouchListener)
    private globalTouchListener: GlobalTouchListener = null;

    @property(cc.Label)
    private infoLb: cc.Label = null;

    onEnable() {
        this.globalTouchListener.on(cc.Node.EventType.TOUCH_END, this.onGloablTouchEnd, this);
    }

    onDisable() {
        this.globalTouchListener.off(cc.Node.EventType.TOUCH_END, this.onGloablTouchEnd, this);
    }

    private onGloablTouchEnd(touch: cc.Touch, event: cc.Event): void {
        this.infoLb.string += "G";
    }

    private onBlueBtnClicked(event: cc.Event, str: string): void {
        this.infoLb.string += "B";
    }

    private onRedBtnClicked(event: cc.Event, str: string): void {
        this.infoLb.string += "R";
    }
}