"use strict";
cc._RF.push(module, '47b98g3YXtHsppD/3gIaUDs', 'GlobalTouchListener');
// script/GlobalTouchListener.ts

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlobalTouchListener = void 0;
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var GlobalTouchListener = /** @class */ (function (_super) {
    __extends(GlobalTouchListener, _super);
    function GlobalTouchListener() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.left = 0;
        _this.right = 0;
        _this.top = 0;
        _this.bottom = 0;
        _this.touchStartCallbackMap = new Map();
        _this.touchMoveCallbackMap = new Map();
        _this.touchEndCallbackMap = new Map();
        _this.touchCancelCallbackMap = new Map();
        return _this;
    }
    GlobalTouchListener.prototype.onLoad = function () {
        var _this = this;
        var newTouchListener = cc["EventListener"].create({
            event: cc["EventListener"].TOUCH_ONE_BY_ONE,
            swallowTouches: false,
            owner: this,
            onTouchBegan: function (touch, event) {
                if (_this.isTouchInArea(touch)) {
                    _this.touchStartCallbackMap.forEach(function (target, callback) {
                        callback.call(target, touch, event);
                    });
                    return true;
                }
                else
                    return false;
            },
            onTouchMoved: function (touch, event) {
                _this.touchMoveCallbackMap.forEach(function (target, callback) {
                    callback.call(target, touch, event);
                });
            },
            onTouchEnded: function (touch, event) {
                if (_this.isTouchInArea(touch)) {
                    _this.touchEndCallbackMap.forEach(function (target, callback) {
                        callback.call(target, touch, event);
                    });
                }
                else {
                    _this.touchCancelCallbackMap.forEach(function (target, callback) {
                        callback.call(target, touch, event);
                    });
                }
            }
        });
        cc["internal"].eventManager.addListener(newTouchListener, -1);
    };
    GlobalTouchListener.prototype.start = function () {
        this.left = this.node.x - this.node.width / 2;
        this.right = this.node.x + this.node.width / 2;
        this.top = this.node.y + this.node.height / 2;
        this.bottom = this.node.y - this.node.height / 2;
    };
    GlobalTouchListener.prototype.on = function (type, call, target) {
        switch (type) {
            case cc.Node.EventType.TOUCH_START:
                this.touchStartCallbackMap.set(call, target);
                break;
            case cc.Node.EventType.TOUCH_MOVE:
                this.touchMoveCallbackMap.set(call, target);
                break;
            case cc.Node.EventType.TOUCH_END:
                this.touchEndCallbackMap.set(call, target);
                break;
            case cc.Node.EventType.TOUCH_CANCEL:
                this.touchCancelCallbackMap.set(call, target);
                break;
            default:
                break;
        }
    };
    GlobalTouchListener.prototype.off = function (type, callback, target) {
        switch (type) {
            case cc.Node.EventType.TOUCH_START:
                if (callback == null)
                    this.touchStartCallbackMap.clear();
                else if (this.touchStartCallbackMap.has(callback) && (target == null || target === this.touchStartCallbackMap.get(callback)))
                    this.touchStartCallbackMap.delete(callback);
                break;
            case cc.Node.EventType.TOUCH_MOVE:
                if (callback == null)
                    this.touchMoveCallbackMap.clear();
                else if (this.touchMoveCallbackMap.has(callback) && (target == null || target === this.touchMoveCallbackMap.get(callback)))
                    this.touchMoveCallbackMap.delete(callback);
                break;
            case cc.Node.EventType.TOUCH_END:
                if (callback == null)
                    this.touchEndCallbackMap.clear();
                else if (this.touchEndCallbackMap.has(callback) && (target == null || target === this.touchEndCallbackMap.get(callback)))
                    this.touchEndCallbackMap.delete(callback);
                break;
            case cc.Node.EventType.TOUCH_CANCEL:
                if (callback == null)
                    this.touchCancelCallbackMap.clear();
                else if (this.touchCancelCallbackMap.has(callback) && (target == null || target === this.touchCancelCallbackMap.get(callback)))
                    this.touchCancelCallbackMap.delete(callback);
                break;
            default:
                break;
        }
    };
    GlobalTouchListener.prototype.isTouchInArea = function (touch) {
        var worldPos = touch.getLocation();
        var nodePos = this.node.parent.convertToNodeSpaceAR(worldPos);
        var x = nodePos.x;
        var y = nodePos.y;
        if (x < this.left || x > this.right || y > this.top || y < this.bottom)
            return false;
        else
            return true;
    };
    GlobalTouchListener = __decorate([
        ccclass
    ], GlobalTouchListener);
    return GlobalTouchListener;
}(cc.Component));
exports.GlobalTouchListener = GlobalTouchListener;

cc._RF.pop();